/*----------------------------------------------------------
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version
2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU General Public License for more
details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

The original author of this program is Hin Jang
March 20, 2003
-----------------------------------------------------------*/

// ----------------------------------------------------------
// vertex.h (could have been defined as a struct instead)
// ----------------------------------------------------------

#ifndef __VERTEX_H__
#define __VERTEX_H__

class Vertex
{

public:

  Vertex();
  ~Vertex();

  // enumeration of vertex types
  //

  enum { Regular = 0, Dart, Crease, ConvexCorner,
	 ConcaveCorner };

  double p[3];   // Cartesian coordinates
  double c[4];   // RGBA colour 
  double n[3];   // normal
  int id;        // id of this vertex
  int tag;       // type of vertex

  int subLevel;  // subdivision level at which this vertex
                 // occupies

  int pid;       // id of the base mesh polygon 

  void clear(void);

};

#endif // __VERTEX_H__
